#pragma once

#ifdef FITCANBUS_EXPORTS
#define  FITCANBUS_API __declspec(dllexport)
#else
#define  FITCANBUS_API __declspec(dllimport)
#endif

#define CANBUS_MAX_DATA_SIZE	8
#define CANBUS_MAX_FILTER_SIZE	15

namespace FITAPI
{
	class FITCANBUS_API CFitekCanBusControl
	{
	public:
        enum class CanFrameFormat {
			CP_29Bit,
			CP_11Bit
		};
		struct  CanFrameInfor {
			CanFrameFormat type;
			BYTE	rtr;
			DWORD	id;
			BYTE	data_len;
			BYTE	data[CANBUS_MAX_DATA_SIZE];
		};
		typedef void(CALLBACK *CanFrameInforProc)(long error, CanFrameInfor* msg);
		CFitekCanBusControl(void);
		~CFitekCanBusControl(void);
		long FintekCanbus_Open(IN char* sComPortNumber);
		long FintekCanbus_Close(IN char* sComPortNumber);
        long FintekCanbus_SetBaudRate(IN char* sComPortNumber, IN DWORD BaudRate);
		long FintekCanbus_GetBaudRate(IN char* sComPortNumber, OUT DWORD* BaudRate);
		long FintekCanbus_SetFilter(IN char* sComPortNumber, IN DWORD pattern, IN DWORD mask);
		long FintekCanbus_ClearFilter(IN char* sComPortNumber);
		long FintekCanbus_Receive(IN char* sComPortNumber, IN CanFrameInforProc callback);
		long FintekCanbus_SetId(IN char* sComPortNumber, IN CanFrameFormat type, IN DWORD id);
		long FintekCanbus_Send(IN char* sComPortNumber,	CanFrameInfor* msg);
		long FintekCanbus_GetIdVal(IN char* sComPortNumber, OUT UCHAR* IdVal);
	private:
	};
}